/* f103bsp.h (20210628 hhwang)

    - stm32f429ii board support package

    - target board
      1) driver board for step moter.
*/

#include "stm32f4xx.h"
#include "stm32f4xx_gpio.h"

typedef struct _BSP_{

  unsigned char Timer0;
  unsigned char Timer1;
  void (*SetTimer0)();
  void (*ResetTimer0)();
  void (*SetTimer1)();
  void (*ResetTimer1)();
  
}BSP;
extern BSP* bsp;

void BspInit(void);
void SetTimer0(void);
void SetTimer1(void);
void ResetTimer0(void);
void ResetTimer1(void);


/* LED */
void LedInit(void);
void LedOn(void);
void LedOff(void);
void Led0Toggle(void);
void Led1Toggle(void);


/* Timer */
void TimerInit(void);