/* f103bsp.h (20210624 hhwang)

    - stm32f103 board support package

    - target board
      1) driver board for step moter.
*/

#include "stm32f10x.h"
#include "stm32f10x_gpio.h"

typedef struct _BSP_{

  unsigned char Timer0;
  unsigned char Timer1;
  void (*SetTimer0)();
  void (*ResetTimer0)();
  void (*SetTimer1)();
  void (*ResetTimer1)();
  
}BSP;
extern BSP* bsp;

void BspInit(void);
void SetTimer0(void);
void SetTimer1(void);
void ResetTimer0(void);
void ResetTimer1(void);

/* GPIO */
void GpioInit(void);

/* LED */
void LedInit(void);
void LedOn(void);
void LedOff(void);
void LedToggle(void);


/* Timer */
void TimerInit(void);

/* PLL Clock */
void UserClockSetting();